package jPrint;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.print.PrinterException;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.text.MessageFormat;

import javafx.scene.control.Label;
import javafx.scene.control.TableView;
import javafx.scene.control.TextArea;

import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.SimpleDoc;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.Copies;
import javax.print.attribute.standard.Sides;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.text.JTextComponent;

import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@Author("Daestrum")
@Version(1.00f)
@ShortName("jPrint")
public class jPrint {
	private JTextComponent jt;
	private JTable jtab;
	private String type;
	private DocPrintJob job;
	private PrintRequestAttributeSet aset;
	private Doc myDoc;
	private JScrollPane scrollPane;

	public jPrint() {
		// TODO Auto-generated constructor stub
	}

	public String print(Object t) {
		if (t == null) {
			return "I can print the following:\r" + "TextAreas\r"
					+ "TextField\r\r"
					+ "Use log around the print call to see what I\r"
					+ "think I am printing";
		}
		Class<? extends Object> c = t.getClass();
		type = c.getSimpleName();
		System.out.println(">>" + type + "<<");
		switch (type.toLowerCase()) {
		case "textarea": {
			jt = new JTextArea();
			jt.setText(((TextArea) t).getText());
			break;
		}
		case "tableview": {
			// Grab column labels from table
			int colcnt = ((TableView<?>) t).getColumns().size();
			String[] cnames = new String[colcnt];

			for (int x = 0; x < colcnt; x++) {
				String colname = ((TableView<?>) t).getColumns().get(x)
						.getText();
				cnames[x] = colname;
				System.out.println("col name " + colname);
			}
			// make a local copy of the table
			TableView<?> testView = (TableView<?>) t;

			// number of items in each row
			int rowlen = testView.getItems().size();
			// ************* Warning horrible code follows *******************
			Object[][] myTable = new Object[rowlen][colcnt];
			//myTable[0] = cnames; // force headers into table
			for (int rowcounter = 0; rowcounter < rowlen; rowcounter++) {
				Object[] inRow = (Object[]) testView.getItems().get(rowcounter);
				for (int data = 0; data < colcnt; data++) {
					Class<? extends Object> cn = inRow[data].getClass();
					String datatype = cn.getSimpleName();
					System.out.println("type -->" + datatype);
					if (datatype.equals("String")) {
						System.out.println("data >> " + inRow[data].toString());
						myTable[rowcounter][data] = inRow[data].toString();
					} else if (datatype.equals("Label")) {
						System.out.println("data >> "
								+ ((Label) inRow[data]).getText());
						myTable[rowcounter][data] = ((Label) inRow[data])
								.getText();
					}
				}
			}
			// ******************* end of horrible code *******************
			JFrame jf = new JFrame();
			jtab = new JTable(myTable, cnames);
			scrollPane = new JScrollPane(jtab);
			jf.add(scrollPane, BorderLayout.CENTER);
			Dimension d = new Dimension();
			d.width = (int) ((TableView<?>) t).getWidth() + 100;
			d.height = (int) ((TableView<?>) t).getHeight() + 100;
			jf.setSize(d);
			jf.setTitle("test table");
			//jf.add(jtab);
			jf.setVisible(true);
			// jtab.print();
			(new Thread(new printTable())).start();
			return "table printed";
		}
		case "textfield": {
			jt = new JTextField();
			jt.setText(((javafx.scene.control.TextField) t).getText());
			break;
		}
		}
		if (jt != null) {
			(new Thread(new printMe())).start();
			return "Printing a [" + type + "]";
		} else {
			return "Failed to Print [" + type + "] <don't know how to yet>";
		}
	}

	public String printFile(String filename) {
		FileInputStream textStream = null;
		try {
			textStream = new FileInputStream(filename);
		} catch (FileNotFoundException ffne) {
		}
		if (textStream == null) {
			return "Nothing to print";
		}
		// Set the document type
		DocFlavor myFormat = DocFlavor.INPUT_STREAM.AUTOSENSE;
		
		// Create a Doc
		myDoc = new SimpleDoc(textStream, myFormat, null);
		// Build a set of attributes
		aset = new HashPrintRequestAttributeSet();
		aset.add(new Copies(1));
		// aset.add(MediaSize.getMediaSizeForName(MediaSizeName.ISO_A4));
		// MediaSize ms = MediaSize.getMediaSizeForName(MediaSizeName.ISO_A4);
		// System.out.println(ms);
		// aset.add(ms); // could not get this to work -
		// docs say it isn't implemented, wish I had read it earlier :)
		aset.add(Sides.ONE_SIDED);
		// discover the printers that can print the format according to the
		// instructions in the attribute set
		// PrintService[] services = PrintServiceLookup.lookupPrintServices(
		// myFormat, null);
		PrintService defaultService = PrintServiceLookup
				.lookupDefaultPrintService();
		if (defaultService != null) {
			System.out.println("Printing to : " + defaultService.getName());
			job = defaultService.createPrintJob();
			(new Thread(new printFileJob())).start();
		} else {
			System.out.println("Oops, can't find default printer");
		}

		// myFormat, aset);
		// Create a print job from one of the print services
		// if (services.length > 0) {
		// for (int pc = 0; pc < services.length; pc++) {
		// System.out.println("Printer <" + pc + "> "
		// + services[pc].getName());
		// }
		// job = services[2].createPrintJob(); // this is my printer it may not
		// // be yours
		// (new Thread(new printFileJob())).start();
		// } else {
		// System.out.println("Oops, can't find suitable printer");
		// }
		return "ok";
	}

	private class printFileJob implements Runnable {
		public void run() {
			try {
				job.print(myDoc, null);
			} catch (PrintException e) {
				e.printStackTrace();
				System.out.println("Sorry, had an error in print job");
			}
		}
	}

	private class printMe implements Runnable {
		public void run() {
			try {
				jt.print();
			} catch (PrinterException e) {
				e.printStackTrace();
			}
		}
	}

	private class printTable implements Runnable {
		public void run() {
			try {
				jtab.print(JTable.PrintMode.FIT_WIDTH,null,new MessageFormat("- {0} -"),true,new  HashPrintRequestAttributeSet(), true);
				//table.print(JTable.PrintMode.NORMAL, headerFormat,footerFormat, true, new  HashPrintRequestAttributeSet(), true);
			} catch (PrinterException e) {
				e.printStackTrace();
			}
		}
	}

}
